//
//  ProgressPanelController.m
//
//  Created by Toshi Nagata.
/*
    Copyright (c) 2008 Toshi Nagata. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "ProgressPanelController.h"

@implementation ProgressPanelController

- (id)initWithTitle: (NSString *)title andCaption: (NSString *)caption
{
    self = [super initWithWindowNibName:@"ProgressPanel"];
	[[self window] setTitle: title];
	[textField setStringValue: caption];
	return self;
}

- (id)beginSession
{
	session = [[NSApplication sharedApplication] beginModalSessionForWindow: [self window]];
	return self;
}

- (BOOL)runSession
{
	return ([[NSApplication sharedApplication] runModalSession: session] == NSRunContinuesResponse);
}

- (id)endSession
{
	[[NSApplication sharedApplication] endModalSession: session];
	return self;
}

- (void)windowDidLoad
{
	canceled = NO;
	[indicator setDoubleValue: 0.0];
}

- (void)setProgressAmount: (double)amount
{
	[indicator setDoubleValue: amount];
}

- (BOOL)canceled
{
	return canceled;
}

- (IBAction)cancelAction:(id)sender
{
	canceled = YES;
}

@end
